/*****************

   A basic fork
  by Dale Cieslak
  
 *****************/
#include "metals.inc"
#declare HALFPIPE =
difference
   {
   cylinder
      {
      <-1, 0, 0>, <1, 0, 0>, 1
      }
   cylinder
      {
      <-1.1, 0, 0>, <1.1, 0, 0>, .85
      }
   box
      {
      <-1.2, 0, -1.1>, <1.2, 1.1, 1.1>
      }
   }

#declare BEND =
union
   {
   difference
      {
      object {HALFPIPE}
      box
         {
         <-1.2, 0, -1.1>, <1.2, 1.1, 1.1>
         rotate <70, 0, 0>
         }
      scale <1 .5 1>
      rotate <0 90 0>
      }

   difference
      {
      object {HALFPIPE}
      box
         {
         <-1.2, 0, -1.1>, <1.2, 1.1, 1.1>
         rotate <90, 0, 0>
         }
      translate <0 0 1.85>
      rotate <0 90 180>
      scale <1 .5 1>
      }

   box
      {
      <-1, -.075, -3>, <1, .075, 0>
      rotate <170, 90, 0>
      translate <.3, -.9, 0>
      scale <1 .5 1>
      }
   box
      {
      <-.25, -.075, -5>, <.25, .075, 0>
      rotate <0, 90, 0>
      translate <-1.75, .95, 0>
      scale <1 .5 1>
      }

   }

#declare FORK =
difference
   {
   object {BEND}
   cylinder
      {
      <0 0 0>, <0 0 2>, .5
      rotate <90, 0, 0>
      translate <-1.0, 1, .65>
      scale <2 1 1.5>
      }
   cylinder
      {
      <0 0 0>, <0 0 2>, .5
      rotate <90, 0, 0>
      translate <-1.0, 1, -.65>
      scale <2 1 1.5>
      }
   box
      {
      <-.125, -1, -3>, <.125, 1, 1>
      rotate <0, 90, 0>
      translate <3.5, 0, 0>
      }
   box
      {
      <-.125, -1, -3>, <.125, 1, 1>
      rotate <0, 90, 0>
      translate <3.5, 0, .6>
      }
   box
      {
      <-.125, -1, -3>, <.125, 1, 1>
      rotate <0, 90, 0>
      translate <3.5, 0, -.6>
      }
   //pigment {color red .8 green .8 blue .8}
   //finish {ambient .4 reflection 0.5 phong .75 phong_size 75}
   texture {T_Silver_3C}
   scale <.25 .25 .25>
   }
